AlphaMetrixForms/AlphaMetrixForms.Web/Models/Response/AnswerViewModel.cs
using AlphaMetrixForms.Web.Models.Enums;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace AlphaMetrixForms.Web.Models.Response
{
    public class AnswerViewModel
    {
        public AnswerViewModel()
        {
            this.Answers = new List<string>();
        }
        public Guid Id { get; set; }
        public string Text { get; set; }
        public QuestionType Type { get; set; } 
        public string Answer { get; set; }

        // Options
        public IList<string> Answers { get; set; }
        public int OrderNumber { get; set; }
    }
}

AlphaMetrixForms/AlphaMetrixForms.Web/Models/Response/ResponseDisplayModel.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace AlphaMetrixForms.Web.Models.Response
{
    public class ResponseDisplayModel
    {
        public ResponseDisplayModel()
        {
            Answers = new List<AnswerViewModel>();
        }
        public string Title { get; set; }
        public string Description { get; set; }
        public List<AnswerViewModel> Answers { get; set; }
    }
}

AlphaMetrixForms/AlphaMetrixForms.Web/Models/Response/ResponseViewModel.cs
using AlphaMetrixForms.Web.Models.Question;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace AlphaMetrixForms.Web.Models.Response
{
    public class ResponseViewModel
    {
        public ResponseViewModel()
        {
            Questions = new List<QuestionViewModel>();
        }
        public Guid Id { get; set; }
        public Guid FormId { get; set; }
        public DateTime CreatedOn { get; set; }
        public string Title { get; set; }
        public string Description { get; set; }
        public List<QuestionViewModel> Questions { get; set; }
    }
}

AlphaMetrixForms/AlphaMetrixForms.Web/Controllers/DocumentQuestionController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using AlphaMetrixForms.Services.Contracts;
using AlphaMetrixForms.Services.Providers.Contracts;
using AlphaMetrixForms.Web.Models.Enums;
using AlphaMetrixForms.Web.Models.Form;
using AlphaMetrixForms.Web.Models.Question;
using Microsoft.AspNetCore.Mvc;

namespace AlphaMetrixForms.Web.Controllers
{
    public class DocumentQuestionController : Controller
    {
        private readonly IBlobProvider _blob;
        private readonly Dictionary<string, string> _typesDictionary;

        public DocumentQuestionController(IBlobProvider blob)
        {
            _blob = blob ?? throw new ArgumentNullException(nameof(blob));
            _typesDictionary = _blob.TypeDict_Setter();
        }
        [HttpPost]
        public IActionResult CreateDocumentQuestion(FormViewModel form)
        {
            QuestionViewModel model = new QuestionViewModel();
            model.OrderNumber = form.Questions.Count;
            model.Type = QuestionType.Document;
            form.Questions.Add(model);

            return PartialView("_QuestionPartial", form);

        }
        public async Task<IActionResult> DownloadFile(string name)
        {
            try
            {
                var stream = await _blob.DownloadFileAsync(name);
                var array = name.Split('.');
                var fileExtension = array[array.Length - 1].ToLower();
                string contentType = _typesDictionary[fileExtension];
                string folderRef = name.Split('/')[0];
                string fileName = name.Substring(folderRef.Length + 1);
                return File(stream, contentType, fileName);
            }
            catch (Exception)
            {
                return NotFound();
            }
        }

    }
}

AlphaMetrixForms/AlphaMetrixForms.Web/Controllers/ResponseController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;
using AlphaMetrixForms.Services.Contracts;
using AlphaMetrixForms.Services.DTOs;
using AlphaMetrixForms.Web.Models.Enums;
using AlphaMetrixForms.Web.Models.Form;
using AlphaMetrixForms.Web.Models.Question;
using AlphaMetrixForms.Web.Models.Response;
using AlphaMetrixForms.Web.Models.User;
using AlphaMetrixForms.Web.Utils;
using AlphaMetrixForms.Web.Utils.Contracts;
using AutoMapper;
using Microsoft.AspNetCore.Mvc;

namespace AlphaMetrixForms.Web.Controllers
{
    public class ResponseController : Controller
    {
        private readonly IFormService _formService;
        private readonly ITextQuestionService _textQuestionService;
        private readonly IOptionQuestionService _optionQuestionService;
        private readonly IDocumentQuestionService _documentQuestionService;
        private readonly IResponseService _responseService;
        private readonly IFactory _factory;
        private readonly IModelGenerator _modelGenerator;
        private readonly IMapper _mapper;


        public ResponseController(IFormService formService, ITextQuestionService textQuestionService, IOptionQuestionService optionQuestionService,
            IDocumentQuestionService documentQuestionService, IResponseService responseService, IMapper mapper, IFactory factory, IModelGenerator modelGenerator)
        {
            _formService = formService ?? throw new ArgumentNullException(nameof(formService));
            _textQuestionService = textQuestionService ?? throw new ArgumentNullException(nameof(textQuestionService));
            _optionQuestionService = optionQuestionService ?? throw new ArgumentNullException(nameof(optionQuestionService));
            _documentQuestionService = documentQuestionService ?? throw new ArgumentNullException(nameof(documentQuestionService));
            _responseService = responseService ?? throw new ArgumentNullException(nameof(responseService));
            _factory = factory ?? throw new ArgumentNullException(nameof(factory));
            _modelGenerator = modelGenerator ?? throw new ArgumentNullException(nameof(factory));
            _mapper = mapper ?? throw new ArgumentNullException(nameof(mapper));
        }
        [HttpPost]
        public async Task<IActionResult> SubmitResponse(ResponseViewModel response)
        {
            string _errorMessage = Validator.ResponseValidation_Message(response);
            if (_errorMessage != null)
            {
                Response.StatusCode = (int)System.Net.HttpStatusCode.BadRequest;
                return Json(new { success = false, responseText = _errorMessage });
            }
            var responseId = await _responseService.CreateResponseAsync(response.FormId);

            await _factory.CreateTextQuestionResponse(response, responseId, _textQuestionService);
            await _factory.CreateOptionQuestionResponse(response, responseId, _optionQuestionService);
            await _factory.CreateDocumentQuestionResponse(response, responseId, _documentQuestionService);
            return Ok();
        }

        [Route("ViewAnswers/{formId}")]
        public async Task<IActionResult> ViewAnswers(Guid formId)
        {
            var result = await this._responseService.RetrieveResponseForFormAsync(formId);
            var vm = _mapper.Map<FormViewModel>(result);
            return View("ViewAnswersView",vm);
        }

        [Route("Response/{formId}")]
        public async Task<IActionResult> DisplayForm(Guid formId)
        {
            var form = await this._formService.GetFormAsync(formId);
            var formVM = _mapper.Map<FormViewModel>(form);

            var textQuestionsVM = _mapper.Map<ICollection<QuestionViewModel>>(form.TextQuestions);
            var optionQuestionsVM = _mapper.Map<ICollection<QuestionViewModel>>(form.OptionQuestions);
            var documentQuestionsVM = _mapper.Map<ICollection<QuestionViewModel>>(form.DocumentQuestions);

            SetQuestionType(QuestionType.Text, formVM, textQuestionsVM);
            SetQuestionType(QuestionType.Option, formVM, optionQuestionsVM);
            SetQuestionType(QuestionType.Document, formVM, documentQuestionsVM);

            ResponseViewModel response = new ResponseViewModel();
            response.FormId = formVM.Id;
            response.Title = formVM.Title;
            response.Description = formVM.Description;
            response.Questions = formVM.Questions.OrderBy(q=>q.OrderNumber).ToList();

            return View("DisplayFormView", response);
        }
        private void SetQuestionType(QuestionType type, FormViewModel formVM, ICollection<QuestionViewModel> questions)
        {
            if (questions != null)
            {
                foreach (var question in questions)
                {
                    if(type == QuestionType.Option)
                    {
                        for (int i = 0; i < question.Options.Count; i++)
                        {
                            question.OptionQuestionAnswerCheckbox.Add(false);
                        }
                    }
                    question.Type = type;
                }
                formVM.Questions.AddRange(questions);
            }
        }

        [Route("RetrieveResponse/{responseId}")]
        public async Task<IActionResult> RetrieveResponse(Guid responseId, Guid formId)
        {
            var formDTO = await _responseService.RetrieveResponseAsync(responseId, formId);
            var vm = new ResponseDisplayModel();
            vm.Title = formDTO.Title;
            vm.Description = formDTO.Description;
            _modelGenerator.Response_TextRelationship(formDTO, vm);
            _modelGenerator.Response_OptionRelationship(formDTO, vm);
            _modelGenerator.Response_DocumentRelationship(formDTO, vm);

            return View("DisplayResponseView", vm);
        }
    }
}

AlphaMetrixForms/AlphaMetrixForms.Web/Views/Response/DisplayFormView.cshtml
@model AlphaMetrixForms.Web.Models.Response.ResponseViewModel

@{
    ViewData["Title"] = "Submit Answer";
}
<link rel="stylesheet" href="~/css/center-card.css" />
<br>
<br>
<div class="row justify-content-center">
    <form id="form" enctype="multipart/form-data" asp-controller="Response" asp-action="SubmitResponse" class="col-8 shadow-lg p-3 mb-5 bg-white">
        <input type="hidden" asp-for="@Model.Title" />
        <h3>@Model.Title</h3>
        <br>
        <h6><b>@Model.Description</h6>
        <input type="hidden" asp-for="@Model.Description" />
        <div id="questions">
            <input type="hidden" asp-for="@Model.FormId">
            @Html.EditorFor(model => model.Questions)
        </div>
        <input type="submit" value="Submit Response" class="btn btn-primary" />
    </form>
</div>
<br>
<br>
<br>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
    <script src="~/js/display-form.js"></script>
}

AlphaMetrixForms/AlphaMetrixForms.Web/Views/Response/DisplayResponseView.cshtml
@model AlphaMetrixForms.Web.Models.Response.ResponseDisplayModel

@{
    ViewData["Title"] = "DisplayResponseView";
}

@{
    string fileName = " ";

}
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
<link rel="stylesheet" href="~/css/download-button.css" />
<link rel="stylesheet" href="~/css/center-card.css" />

<br>
<br>

<div class="row justify-content-center">
    <form class="col-8 shadow-lg p-3 mb-5 bg-white align-items-center">
        <h3>@Model.Title</h3>
        <input type="hidden" asp-for="@Model.Title" />
        <h6>@Model.Description</h6>
        <input type="hidden" asp-for="@Model.Description" />
        <br>
        <div id="answers">
            @foreach (var answer in Model.Answers.OrderBy(a => a.OrderNumber))
            {
                if (answer.Type == AlphaMetrixForms.Web.Models.Enums.QuestionType.Text)
                {
                    <br>
                    <div class="card card col-10 shadow-lg p-3 mb-5 bg-white rounded" id="textCard">
                        <div class="card-header">
                            <label for="Title">@answer.Text</label>
                        </div>
                        <div class="card-body">
                            <div class="col-md-12">
                                <div class="form-group">
                                    <h4>@answer.Answer</h4>
                                </div>
                            </div>
                        </div>
                    </div>
                    <br>
                }
                else if (answer.Type == AlphaMetrixForms.Web.Models.Enums.QuestionType.Option)
                {
                    <br>
                    <div class="card card col-10 shadow-lg p-3 mb-5 bg-white rounded" id="optionCard">
                        <div class="card-header">
                            <label for="Title">@answer.Text</label>
                        </div>
                        <div class="card-body">
                            <div class="col-md-12">
                                <div class="form-group">
                                    @foreach (var text in answer.Answers)
                                    {
                                        <h4>* @text</h4>
                                    }
                                </div>
                            </div>
                        </div>
                    </div>
                    <br>
                }
                else if (answer.Type == AlphaMetrixForms.Web.Models.Enums.QuestionType.Document)
                {
                    <br>
                    <div class="card card col-10 shadow-lg p-3 mb-5 bg-white rounded" id="documentCard">
                        <div class="card-header">
                            <label for="Title">@answer.Text</label>
                        </div>
                        <div class="card-body">
                            <div class="col-md-12">
                                <div class="form-group">

                                    @for (int i = 0; i < answer.Answers.Count; i++)
                                    {
                                        fileName = @answer.Answers[i].Split('/')[1];
                                        if (fileName.Length > 20)
                                        {
                                            fileName = fileName.Substring(0, 20) + "...";
                                        }
                                        <a button class="btn download" asp-controller="DocumentQuestion" asp-action="DownloadFile" asp-route-name="@answer.Answers[i]"><i class="fa fa-download">@fileName</i></a>
                                    }
                                </div>
                            </div>
                        </div>
                    </div>
                    <br>
                }
            }
        </div>
    </form>
</div>
@*</div>
    </div>*@
<br>
<br>
<br>

AlphaMetrixForms/AlphaMetrixForms.Web/Views/Response/ViewAnswersView.cshtml
@model AlphaMetrixForms.Web.Models.Form.FormViewModel

@{
    ViewData["Title"] = "View Answers";
}
<br>
<div class="card">
    <div class="card-body">
        <h3>@Model.Title</h3>
        <h5>@Model.Description</h5>
        <br>

        @if (@Model.Responses.Count == 0)
        {
            <p class="text-center">No responses are submitted for this form yet.</p>
        }
        else
        {
            <table class="table">
                <thead>
                    <tr>
                        <th scope="col">Number</th>
                        <th scope="col">Submitted on</th>
                        <th scope="col">View Response</th>
                    </tr>
                </thead>
                <tbody>
                    @for (int i = 1; i <= @Model.Responses.Count; i++)
                    {
                        <tr>
                            <td>@i</td>
                            <td>@Model.Responses[i - 1].CreatedOn</td>
                            <td><a class="btn btn-primary" role="button" asp-action="RetrieveResponse" asp-route-responseId="@Model.Responses[i-1].Id" asp-route-formId="@Model.Id">View</a></td>
                        </tr>
                    }
                </tbody>
            </table>
        }
    </div>
</div>
<br>
<br>
<br>